## gprbuild 2024.1.20231009

=== Makefile ===
# Makefile targets
# ----------------
#
# Setup:                   make [VAR=VALUE] setup (see below)
# Build gprbuild:          make all
# Install gprbuild:        make install
# Create gprbuild package: make distall
# Build tool <TOOL>:       make <TOOL>
# Build libgpr:            make libgpr.build
# Install libgpr:          make libgpr.install
# (for libgpr you can add ".type" where type is static, static-pic or shared
#  build a specific version of the lib. by default all supported variants are
#  built).

# Variables which can be set:
#
#   ENABLE_SHARED : yes / no (or empty)
#   BUILD         : debug production coverage profiling
#   PROCESSORS    : nb parallel compilations (0 to use all cores)
#   TARGET        : target triplet for cross-compilation
#
# Out-of-tree build:
#
#   $ make -f <GPRBUILD_TREE>/Makefile setup
#   $ make -f <GPRBUILD_TREE>/Makefile

HOST    = $(shell gcc -dumpmachine)
TARGET := $(shell gcc -dumpmachine)

prefix	      := $(dir $(shell which gnatls))..
BUILD         = production
PROCESSORS    = 0
BUILD_DIR     =
SOURCE_DIR    := $(shell dirname "$(MAKEFILE_LIST)")
LIB_DIR       = lib/

# Load current setup if any
-include makefile.setup

# target options for cross-build
ifeq ($(HOST),$(TARGET))
GTARGET=
# INSTALLER=exe/$(BUILD)/$(LIB_INSTALLER)
else
GTARGET=--target=$(TARGET)
endif

INSTALLER=$(LIB_INSTALLER)
EXEC_INSTALLER=$(INSTALLER) -XBUILD=${BUILD}

# check for out-of-tree build
ifeq ($(SOURCE_DIR),.)
RBD=
GPRBUILD_GPR=gprbuild.gpr
GPR_GPR=gpr/gpr.gpr
MAKEPREFIX=
else
RBD=--relocate-build-tree
GPRBUILD_GPR=$(SOURCE_DIR)/gprbuild.gpr
GPR_GPR=$(SOURCE_DIR)/gpr/gpr.gpr
MAKEPREFIX=$(SOURCE_DIR)/
endif

ENABLE_SHARED := $(shell gprbuild $(GTARGET) -c -q -p \
	-P$(MAKEPREFIX)config/test_shared 2>/dev/null && echo "yes")

ifeq ($(ENABLE_SHARED), yes)
   LIBGPR_TYPES=static shared static-pic
else
   LIBGPR_TYPES=static
endif

# Make sure Windows's "OS" environment variable does not cause
# confusion for cross-Linux builds.
LIBGPR_OS = $(if $(findstring linux,$(TARGET)),-XOS=UNIX)

# Used to pass extra options to GPRBUILD, like -d for instance
GPRBUILD_OPTIONS=

BUILDER=gprbuild -p -m $(GTARGET) $(RBD) -j${PROCESSORS} -XBUILD=${BUILD} ${GPRBUILD_OPTIONS}
LIB_INSTALLER=gprinstall -p -f --target=$(TARGET) $(RBD) "--prefix=${prefix}"
CLEANER=gprclean -q $(RBD)

GPRBUILD_BUILDER=$(BUILDER) $(GPRBUILD_GPR) \
	-XLIBRARY_TYPE=static -XXMLADA_BUILD=static
LIBGPR_BUILDER=$(BUILDER) $(GPR_GPR) $(LIBGPR_OS)
LIBGPR_INSTALLER=$(LIB_INSTALLER) $(GPR_GPR) $(LIBGPR_OS) -XBUILD=${BUILD} \
	--install-name=gpr \
	--build-var=LIBRARY_TYPE --build-var=GPR_BUILD $(GTARGET)
LIBGPR_UNINSTALLER=$(LIB_INSTALLER) $(GPR_GPR) $(LIBGPR_OS) --install-name=gpr --uninstall

#########
# build #
#########

.PHONY: all distall gprbuild gprconfig gprclean gprinstall gprname gprls

build all:
	$(GPRBUILD_BUILDER)

distall: all install

gprbuild:
	$(GPRBUILD_BUILDER) gprbuild-main.adb

gprinstall:
	$(GPRBUILD_BUILDER) gprinstall-main.adb

gprclean:
	$(GPRBUILD_BUILDER) gprclean-main.adb

gprconfig:
	$(GPRBUILD_BUILDER) gprconfig-main.adb

gprname:
	$(GPRBUILD_BUILDER) gprname-main.adb

gprls:
	$(GPRBUILD_BUILDER) gprls-main.adb

#################################
# Gprbuild installation targets #
#################################

.PHONY: install

install:
	$(EXEC_INSTALLER) --mode=usage --install-name=gprbuild \
		-XINSTALL_MODE=nointernal $(GPRBUILD_GPR)
	$(EXEC_INSTALLER) --target=$(TARGET) --mode=usage  --install-name=gprbuild \
		-XINSTALL_MODE=internal $(GPRBUILD_GPR)

complete: all install libgpr.install.static

##########
# Libgpr #
##########

.PHONY: libgpr.build libgpr.build.static libgpr.build.shared libgpr.build.static-pic
.PHONY: libgpr.install libgpr.install.static libgpr.install.shared libgpr.install.static-pic
.PHONY: libgpr.uninstall

libgpr.build: $(foreach t, $(LIBGPR_TYPES), libgpr.build.$(t))

libgpr.build.shared:
	${LIBGPR_BUILDER} -XLIBRARY_TYPE=relocatable \
		-XXMLADA_BUILD=relocatable

libgpr.build.static:
	${LIBGPR_BUILDER} -XLIBRARY_TYPE=static \
		-XXMLADA_BUILD=static

libgpr.build.static-pic:
	${LIBGPR_BUILDER} -XLIBRARY_TYPE=static-pic \
		-XXMLADA_BUILD=static-pic

libgpr.install: libgpr.uninstall $(foreach t, $(LIBGPR_TYPES), libgpr.install.$(t))

libgpr.install.static:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=static \
	   -XXMLADA_BUILD=static \
	   --lib-subdir=${LIB_DIR}/gpr/static \
	   --build-name=static

libgpr.install.static-pic:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=static-pic \
	   -XXMLADA_BUILD=static-pic \
	   --lib-subdir=${LIB_DIR}/gpr/static-pic \
	   --build-name=static-pic

libgpr.install.shared:
	$(LIBGPR_INSTALLER) \
	   -XLIBRARY_TYPE=relocatable \
	   -XXMLADA_BUILD=relocatable \
	   --lib-subdir=${LIB_DIR}/gpr/relocatable \
	   --build-name=relocatable

libgpr.uninstall:
	-$(LIBGPR_UNINSTALLER)

libgpr.clean:
	-$(CLEANER) -XLIBRARY_TYPE=relocatable $(GPR_GPR)
	-$(CLEANER) -XLIBRARY_TYPE=static $(GPR_GPR)
	-$(CLEANER) -XLIBRARY_TYPE=static-pic $(GPR_GPR)
	rm -fr gpr/lib gpr/libobj

#########
# setup #
#########

.SILENT: setup
setup:
	echo "prefix=$(prefix)" > makefile.setup
	echo "ENABLE_SHARED=$(ENABLE_SHARED)" >> makefile.setup
	echo "BUILD=$(BUILD)" >> makefile.setup
	echo "PROCESSORS=$(PROCESSORS)" >> makefile.setup
	echo "TARGET=$(TARGET)" >> makefile.setup
	echo "SOURCE_DIR=$(SOURCE_DIR)" >> makefile.setup

###################
# Cleanup targets #
###################

.PHONY: clean
clean: libgpr.clean
	-$(CLEANER) -r -Pgprbuild -XBUILD=$(BUILD)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=static-pic $(GPR_GPR)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=static $(GPR_GPR)
ifeq ($(ENABLE_SHARED), yes)
	-$(CLEANER) -r -XBUILD=${BUILD} \
		-XLIBRARY_TYPE=relocatable $(GPR_GPR)
	-$(CLEANER) $(GPR_GPR) -XBUILD=$(BUILD) \
		-XLIBRARY_TYPE=relocatable
endif
	make -C $(MAKEPREFIX)doc clean
	make -C $(MAKEPREFIX)examples clean
	rm -fr obj exe makefile.setup

.PHONY: doc examples

doc:
	make -C $(MAKEPREFIX)doc

examples: force
	make -C $(MAKEPREFIX)examples

force:

# Let gprbuild handle parallelization. In general, we don't support parallel
# runs in this Makefile, as concurrent gprinstall processes may crash.
.NOTPARALLEL:

=== doc/Makefile ===
# Makefile for Sphinx documentation

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = .
SOURCEDIR     = .

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) \
		  -c $(SOURCEDIR)/share \
		  -d $(BUILDDIR)/$*/doctrees \
		  $(SOURCEDIR)
FMT_LIST=html txt info pdf
DOC_NAME=gprbuild_ug
CP=cp

.PHONY: help clean

all: $(foreach fmt, $(FMT_LIST), $(fmt))

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  pdf        to make LaTeX files and run them through pdflatex"
	@echo "  txt        to make text files"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make info files"
	@echo "  all                 to build documentation in all formats"
	@echo ""
	@echo "source and location can be overriden using SOURCEDIR and BUILDDIR variables"

clean:
	-rm -rf $(BUILDDIR)/html \
		$(BUILDDIR)/pdf \
		$(BUILDDIR)/txt \
		$(BUILDDIR)/info \
		$(BUILDDIR)/doctrees \
		share/__pycache__

html: force
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html

pdf: force
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/pdf
	cp $(SOURCEDIR)/share/sphinx.sty $(BUILDDIR)/pdf
	$(MAKE) -C $(BUILDDIR)/pdf all-pdf LATEXOPTS="-interaction=nonstopmode"

txt: force
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/txt
	$(MAKE) -C $(BUILDDIR)/txt plaintext

info: force
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/info
	$(MAKE) -C $(BUILDDIR)/info info

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/$*/texinfo

force:

=== examples/namings/Makefile ===
all: default.cgpr
	gprbuild -p -Pnamings -XC1=case1 $(GPRBUILDFLAGS)
	gprbuild -p -Pnamings -XC1=case2 $(GPRBUILDFLAGS)
	gprbuild -p -Pnamings -XC1=case3 $(GPRBUILDFLAGS)

default.cgpr:
	gprconfig --batch --config Ada --config C

clean: default.cgpr
	gprclean -Pnamings -XC1=case1
	gprclean -Pnamings -XC1=case2
	gprclean -Pnamings -XC1=case3
	$(RM) default.cgpr

run: all
	./main-case1
	./main-case2
	./main-case3

.PHONY: all clean run

=== debian/changelog ===
gprbuild (2024.1.20231009-5~24.04) noble; urgency=medium

  * SRU: LP: #2083315: Backport changes for gnat 64bit time_t.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Oct 2024 04:57:30 +0200

gprbuild (2024.1.20231009-5) unstable; urgency=medium

  * source-date-epoch: fix a typo
  * Standards-Version: 4.7.0 (no changes)
  * source-date-epoch: adapt to a private time_t
  * source-date-epoch: fix Source_Date_Time unit (nanoseconds -> seconds)
  * Patch adapting gpr to a private timeval type in libgnat
  * Patch adapting gpr to a private time_t type in libgnat

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 May 2024 13:13:00 +0000

gprbuild (2024.1.20231009-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-13/time_t64 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Mar 2024 14:50:22 +0100

gprbuild (2024.1.20231009-3) experimental; urgency=medium

  * Rebuild with dh-ada-library 9.1 and gnat versions in ada:Depends.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 19 Dec 2023 00:50:20 +0100

gprbuild (2024.1.20231009-2) experimental; urgency=medium

  * Previous upload broke the ABI, update the SOversion in library package.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 25 Oct 2023 11:44:59 +0000

gprbuild (2024.1.20231009-1) experimental; urgency=medium

  * New upstream release.
  * Adapt debian/rules to new source file naming exception.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Oct 2023 21:16:13 +0000

gprbuild (2023.0.0-4) experimental; urgency=medium

  * Build in experimental with dh-ada-library >= 9 and gnat >= 13
  * Rename -dev package, now unversioned. Provide a name containing a hash.
  * Build-Depend: gnat instead of gnat-13. Break/Replace previous -devs.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 24 Oct 2023 16:32:27 +0000

=== debian/control ===
Source: gprbuild
Section: devel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Uploaders: Ludovic Brenta <lbrenta@debian.org>
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Arch:
 dh-ada-library (>= 9.1),
 dh-sequence-ada-library,
 gnat (>= 13),
 libxmlada-dom-dev,
 libxmlada-input-dev,
 libxmlada-sax-dev,
 libxmlada-schema-dev,
# libxmlada_unicode is required indirectly
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
# Sphinx >= 1.6 uses the latexmk driver:
 latexmk,
 python3-sphinx,
# makeinfo:
 texinfo,
# documentation depends on tgtermes.sty:
 tex-gyre,
# ptmr8t.tfm:
 texlive-fonts-recommended,
# fncychap.sty:
 texlive-latex-extra,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/AdaCore/gprbuild
Vcs-Browser: https://salsa.debian.org/debian/gprbuild
Vcs-Git: https://salsa.debian.org/debian/gprbuild.git

Package: libgnatprj11
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: support for programs processing GNAT projects (runtime)
 GNAT projects are human-readable text files used to drive tools
 building or inspecting lots of source files in several programming
 languages, like those provided by the gprbuild package.
 .
 This package contains the runtime shared library.

Package: libgnatprj-dev
Breaks: libgnatprj7-dev, libgnatprj8-dev, libgnatprj9-dev, libgnatprj10-dev
Replaces: libgnatprj7-dev, libgnatprj8-dev, libgnatprj9-dev, libgnatprj10-dev
Provides: ${ada:Provides}
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Suggests: gprbuild-doc
Description: support for programs processing GNAT projects (development)
 GNAT projects are human-readable text files used to drive tools
 building or inspecting lots of source files in several programming
 languages, like those provided by the gprbuild package.
 .
 This package contains the development tools.

Package: gprbuild
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
# 23~20220701-1 sets the now required Bindfile_Option_Substitution attribute
 gprconfig-kb (>= 23~20220701-1),
Suggests: gnat, g++, gcc, gfortran, gprbuild-doc
Description: multi-language extensible build tool
 A set of tools for processing GNAT project files:
 gprconfig detects available compilers,
 gprbuild runs them;
 gprslave helps distributing the build work across the network;
 gprinstall copies the objects to their final destination;
 gprclean removes them.
 The default configuration supports Ada, Assembler, C, C++, Fortran,
 and can be extended to support user source processing tools.

Package: gprbuild-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends},
Built-Using: ${sphinxdoc:Built-Using}
Suggests: gprbuild
# Examples were in the gprbuild package when there was no -doc package.
Replaces: gprbuild (<< 2021.0.0.0778b109-1)
Breaks: gprbuild (<< 2021.0.0.0778b109-1)
Description: multi-language extensible build tool (documentation)
 A set of tools for processing GNAT project files:
 gprconfig detects available compilers,
 gprbuild runs them;
 gprslave helps distributing the build work across the network;
 gprinstall copies the objects to their final destination;
 gprclean removes them.
 The default configuration supports Ada, Assembler, C, C++, Fortran,
 and can be extended to support user source processing tools.
 .
 This package contains the documentation.

=== debian/watch ===
version=4

# For historical reasons, DEB_VERSION_UPSTREAM starts with "20".

opts="uversionmangle=s/^/20/" \
https://github.com/AdaCore/gprbuild/tags \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## gprbuild 2025.0.0

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 #   $ make -f <GPRBUILD_TREE>/Makefile setup
 #   $ make -f <GPRBUILD_TREE>/Makefile
 
-HOST    = $(shell gcc -dumpmachine)
+HOST   := $(shell gcc -dumpmachine)
 TARGET := $(shell gcc -dumpmachine)
 
 prefix	      := $(dir $(shell which gnatls))..

=== doc/Makefile ===
--- 
+++ 
@@ -46,7 +46,6 @@
 
 pdf: force
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/pdf
-	cp $(SOURCEDIR)/share/sphinx.sty $(BUILDDIR)/pdf
 	$(MAKE) -C $(BUILDDIR)/pdf all-pdf LATEXOPTS="-interaction=nonstopmode"
 
 txt: force

=== examples/ada_cpp/Makefile ===
all: default.cgpr
	gprbuild -Panimals $(GPRBUILDFLAGS)
	gprbuild -Pexcept $(GPRBUILDFLAGS)

default.cgpr:
	gprconfig --batch --config Ada --config C++

clean: default.cgpr
	gprclean -Panimals
	gprclean -Pexcept
	$(RM) default.cgpr

run: all
	./ada_main
	./cpp_main
	./main

.PHONY: all clean run

=== examples/ada_f77/Makefile ===
all: default.cgpr
	gprbuild -p -Pft $(GPRBUILDFLAGS)

default.cgpr:
	gprconfig --batch --config Ada --config Fortran

clean: default.cgpr
	gprclean -r -Pft
	$(RM) default.cgpr

run: all
	./fobj/ess

.PHONY: all clean run

=== examples/first_steps/Makefile ===
all: default.cgpr
	gprbuild -p -Pc_main $(GPRBUILDFLAGS)
	gprbuild -p -Pada_main $(GPRBUILDFLAGS)

default.cgpr:
	gprconfig --batch --config Ada --config C

clean: default.cgpr
	gprclean -Pc_main
	gprclean -Pada_main
	$(RM) default.cgpr

run: all
	./ada_main
	./obj1/c_main

.PHONY: all clean run

=== examples/scenarios/Makefile ===
all: default.cgpr
	gprbuild -p -Pmain -XLIB=static $(GPRBUILDFLAGS)
	gprbuild -p -Pmain -XLIB=dynamic $(GPRBUILDFLAGS)


default.cgpr:
	gprconfig --batch --config Ada --config C

clean: default.cgpr
	gprclean -r -Pmain -XLIB=static
	gprclean -r -Pmain -XLIB=dynamic
	$(RM) default.cgpr

run: all
	./obj/main
	PATH="../libraries/lib2:$$PATH" obj1/main

.PHONY: all clean run

=== examples/subsystems/Makefile ===
all: default.cgpr
	gprbuild -p -Pc_main $(GPRBUILDFLAGS)
	gprbuild -p -Pada_main $(GPRBUILDFLAGS)

default.cgpr:
	gprconfig --batch --config Ada --config C

clean: default.cgpr
	gprclean -r -Pc_main
	gprclean -r -Pada_main
	$(RM) default.cgpr

run: all
	./ada_main
	./c_main

.PHONY: all clean run

=== debian/changelog ===
gprbuild (2025.0.0-4build1) questing; urgency=medium

  * No-change rebuild for gnat ABI, triggered by glibc 2.42.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 21 Sep 2025 14:14:44 +0200

gprbuild (2025.0.0-4) unstable; urgency=medium

  * Fix the SOURCE_DATE_EPOCH conversion.  Closes: #1100373.
  * Let tests/source-date-epoch produce more debugging info.
  * Reenable the SOURCE_DATE_EPOCH test.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 15 Apr 2025 14:54:44 +0000

gprbuild (2025.0.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * To proceed with the gnat transition, mark the source-date-epoch test
    as flaky. It currently fails. Addresses: #1100373.

 -- Matthias Klose <doko@debian.org>  Sun, 23 Mar 2025 09:44:02 +0100

gprbuild (2025.0.0-3) unstable; urgency=medium

  * Reupload to unstable for the gnat-14 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 08 Mar 2025 21:33:02 +0100

gprbuild (2025.0.0-2) experimental; urgency=medium

  * Bump Shared Object version of the library (some profiles have changed).
  * Call gnatbind as target-gnatbind-version instead of target-gnatbind,
    which does not exist in Debian.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 30 Dec 2024 19:10:42 +0000

gprbuild (2025.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Build with gnat-14 in experimental.
  * Reduce diff with libxmlada/debian/rules
  * Reduce diff with gnat/ada-lib-info-source-date-epoch.diff
  * source-date-epoch: also truncate in File_Stamp(String).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 27 Nov 2024 19:07:32 +0100

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,8 @@
 Build-Depends-Arch:
  dh-ada-library (>= 9.1),
  dh-sequence-ada-library,
- gnat (>= 13),
+ gnat,
+ gnat-14,
  libxmlada-dom-dev,
  libxmlada-input-dev,
  libxmlada-sax-dev,
@@ -27,13 +28,13 @@
  texlive-fonts-recommended,
 # fncychap.sty:
  texlive-latex-extra,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://github.com/AdaCore/gprbuild
 Vcs-Browser: https://salsa.debian.org/debian/gprbuild
 Vcs-Git: https://salsa.debian.org/debian/gprbuild.git
 
-Package: libgnatprj11
+Package: libgnatprj12
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f
# Build script for GPRBuild in Debian.
# Copyright (c) 2009-2012 Stephen Leake <stephen_leake@stephe-leake.org>
# Copyright (c) 2013-2023 Nicolas Boulenguez <nicolas@debian.org>

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.

# On Debian systems, the full text of the GPL is in the file
# /usr/share/common-licenses/GPL-3.

# NOTE:
# In order to prevent a circular build-dependency, the Debian packages
# for XML/Ada and GPRBuild bother to build without project support.
# Please keep the two debian/rules files similar enough to ease
# backport of good ideas.

######################################################################

DEB_BUILD_MAINT_OPTIONS := hardening=+all
DEB_ADAFLAGS_MAINT_APPEND := -gnatwa -Wall -gnatn
DEB_LDFLAGS_MAINT_APPEND := \
  -Wl,--no-undefined \
  -Wl,--no-copy-dt-needed-entries \
  -Wl,--no-allow-shlib-undefined
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include $(wildcard /usr/share/ada/packaging.mk)
# wildcard in case only Build-Depends-Indep are installed.

# gprbuild.gpr selects inlining.
# It also selects -E -static binder options, but:
# #666106 affects only kfreebsd-i386, where storing tracebacks in
# exception occurrences causes a segmentation fault.  This prevents
# handling of any exceptions.  gprconfig relies on handling exceptions
# when parsing compilers.xml.
# Author: Ludovic Brenta <lbrenta@debian.org>

######################################################################
%:
	dh $@

# Rewrite upstream configure/make build system.
.PHONY: $(addprefix override_dh_auto_, \
  configure build-arch build-indep test install-arch install-indep clean)

# gnatmake does not support projects anymore, we cannot use xmlada.gpr.
# The priority is to bootstrap, not a complete dependency graph.

override_dh_auto_build-arch::
	ln -fs gpr-util-put_resource_usage__unix.adb gpr/src/gpr-util-put_resource_usage.adb
	mkdir -p obj

######################################################################

# For source directories (-aI) and ALI directories (-aO), blindly list
# all build dependencies and append each library once it is
# built. This does not hurt, and covers all direct and indirect
# dependencies.

# For installed shared libraries (-l) and locally built shared
# objects), the same strategy works thanks to --as-needed, which is
# the default since gcc-9, provided a proper ordering.

# Libraries provided by Ada -dev packages in Build-Depends.
ada_build_deps := xmlada_schema xmlada_dom xmlada_sax xmlada_input xmlada_unicode

# These list grow each time the template is expanded.
gnatmakeflags := $(GNATMAKEFLAGS) \
                 $(ada_build_deps:%=-aI/$(DEB_ADA_SOURCE_DIR)/%) \
                 $(ada_build_deps:%=-aO/$(DEB_ADA_LIB_INFO_DIR)/%)
shared_objects_so_far := $(ada_build_deps:%=-l%) \
                         -lgnarl-$(DEB_GNAT_VERSION) \
                         -lgnat-$(DEB_GNAT_VERSION)

define library_template
# Parameters:
# _SRCDIR: directory containing the sources files
# _SO_VERSION : part of the shared object name
# _imported_projects: for the generated project.

  override_dh_auto_build-arch::

	mkdir -p obj/shared_$1 obj/static_$1

  # Build dynamic library.
    # -fPIC/-shared overrides -fPIE/-pie in ADAFLAGS/LDFLAGS.
	gcc-$(DEB_GNAT_VERSION) -c $($1_SRCDIR)/gpr_imports.c \
	  $(CFLAGS) $(CPPFLAGS) -o obj/shared_$1/gpr_imports.o -fPIC
	gnatmake -c `grep -L '^separate ' $($1_SRCDIR)/*.ad[bs] | grep -v __` \
	  $(gnatmakeflags) -D obj/shared_$1 -cargs $(ADAFLAGS) -fPIC
	gcc-$(DEB_GNAT_VERSION) -shared \
	  -o obj/lib$1.so.$($1_SO_VERSION) \
	  -Wl,-soname,lib$1.so.$($1_SO_VERSION) \
	  $(LDFLAGS) obj/shared_$1/*.o $(shared_objects_so_far)

  # Mark ALI files as read-only.
	chmod 444 obj/shared_$1/*.ali

  # Build static library.
	gcc-$(DEB_GNAT_VERSION) -c $($1_SRCDIR)/gpr_imports.c \
	  $(CFLAGS) $(CPPFLAGS) -o obj/static_$1/gpr_imports.o
	gnatmake -c `grep -L '^separate ' $($1_SRCDIR)/*.ad[bs] | grep -v __` \
	  $(gnatmakeflags) -D obj/static_$1 -cargs $(ADAFLAGS)
	ar rc obj/lib$1.a obj/static_$1/*.o
	ranlib obj/lib$1.a

  # Externally built project installed for end users.
	sed ' \
	  /@IMPORTS@/ { \
	    s//$($1_imported_projects:%=with "%.gpr";\n)/; \
	    s/\n /\n/g; }; \
	  s/@library@/$1/; \
	  s|@DEB_LIB_DIR@|$(DEB_LIB_DIR)|; \
	  s|@DEB_ADA_SOURCE_DIR@|$(DEB_ADA_SOURCE_DIR)|; \
	  s|@DEB_ADA_LIB_INFO_DIR@|$(DEB_ADA_LIB_INFO_DIR)|; \
	  ' debian/template.gpr > obj/$1.gpr

  override_dh_auto_install-arch::
	install -m644 -Dtdebian/tmp/$(DEB_ADA_SOURCE_DIR)/$1 $($1_SRCDIR)/*.ad[bs] \
	  $($1_SRCDIR)/gpr_imports.c
	install -m444 -Dtdebian/tmp/$(DEB_ADA_LIB_INFO_DIR)/$1 obj/shared_$1/*.ali
	install -m644 -Dtdebian/tmp/$(DEB_GNAT_PROJECT_DIR) obj/$1.gpr
	install -m644 -Dtdebian/tmp/$(DEB_LIB_DIR) \
	  obj/lib$1.so.$($1_SO_VERSION) obj/lib$1.a
	ln -fs lib$1.so.$($1_SO_VERSION) debian/tmp/$(DEB_LIB_DIR)/lib$1.so

  gnatmakeflags += -aI$($1_SRCDIR) -aOobj/shared_$1
  shared_objects_so_far := obj/lib$1.so.$($1_SO_VERSION) \
                           $(shared_objects_so_far)
endef

gnatprj_SRCDIR := gpr/src
gnatprj_imported_projects := xmlada_schema xmlada_dom xmlada_sax xmlada_input
$(eval $(call library_template,gnatprj))

######################################################################

args_for_tools := \
  -D obj $(gnatmakeflags) \
  -cargs $(ADAFLAGS) \
  -largs $(LDFLAGS) $(shared_objects_so_far)

override_dh_auto_build-arch::
	gnatmake src/gprbind.adb         -o obj/gprbind    $(args_for_tools)
	gnatmake src/gprbuild-main.adb   -o obj/gprbuild   $(args_for_tools)
	gnatmake src/gprclean-main.adb   -o obj/gprclean   $(args_for_tools)
	gnatmake src/gprconfig-main.adb  -o obj/gprconfig  $(args_for_tools)
	gnatmake src/gprinstall-main.adb -o obj/gprinstall $(args_for_tools)
	gnatmake src/gprlib.adb          -o obj/gprlib     $(args_for_tools)
	gnatmake src/gprls-main.adb      -o obj/gprls      $(args_for_tools)
	gnatmake src/gprname-main.adb    -o obj/gprname    $(args_for_tools)
	gnatmake src/gprslave.adb        -o obj/gprslave   $(args_for_tools)

######################################################################
override_dh_auto_build-indep:
  ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
    # Enable parallelism in sphinx, but not in Make (#1008152).
	$(MAKE) -C doc html pdf txt \
	  $(DEB_BUILD_OPTION_PARALLEL:%=SPHINXOPTS=-j%)
  endif
override_dh_auto_clean:
	$(MAKE) -Cdoc clean

# Compatibility project with upstream name GPR.
execute_after_dh_install-arch:
	dh_install --package=libgnatprj-dev \
	  debian/gpr.gpr \
	  $(DEB_GNAT_PROJECT_DIR)

=== debian/tests/control ===
Tests: archive-builder
Depends: gprbuild, gcc

Tests: ada-policy-project-with-dash-s link-with-shared gpr-wrapper
Depends: @, gnat

Tests: link-library-as-needed-z-defs
Depends: gprbuild, gnat

Tests: source-date-epoch
Depends: gprbuild, gnat

Tests: examples
Depends: gprbuild, gnat, gcc, g++, gfortran, make, gprbuild-doc

Tests: do-not-strip-minor-soversion
Depends: gprbuild, gnat, binutils
